#include <iostream>
#include <cuda.h>
#include <stdio.h>
#include <stdlib.h>
#include <sys/time.h>
using namespace std;

__global__ void kernel_gpu(int *A0,float *B0,int N){
int i = blockIdx.x * blockDim.x + threadIdx.x;
if (i < N){
A0[i] = A0[i]/A0[i];
B0[i] = B0[i]+B0[i];
}
}

void kernel_cpu(int *A0,float *B0,int N){
for(int i=0;i<N;i++){
A0[i] = A0[i]/A0[i];
B0[i] = B0[i]+B0[i];
}
}

int main(int argc,char **argv) {
fprintf(stderr, "8 ");
int size=977711;
int intBytes = size*sizeof(int);
int floatBytes = size*sizeof(float);
int *A0;
A0 = (int *)malloc(intBytes);
float *B0;
B0 = (float *)malloc(floatBytes);
for(int i=0;i<977711;i++){
A0[i] = 79+i+1;
B0[i] = 60.8510217872*i+1;
}
int *d_A0;
cudaMalloc((void **)&d_A0,977711*sizeof(int));
cudaMemcpy(d_A0,A0,977711*sizeof(int),cudaMemcpyHostToDevice);
float *d_B0;
cudaMalloc((void **)&d_B0,977711*sizeof(float));
cudaMemcpy(d_B0,B0,977711*sizeof(float),cudaMemcpyHostToDevice);
int n = 3820*256;
int block_size = 256;
int block_no = n/block_size;
struct timeval time0,time1;
gettimeofday(&time0,NULL);
kernel_gpu<<<block_no,block_size>>>(d_A0,d_B0,977711);
cudaThreadSynchronize();
gettimeofday(&time1,NULL);
double totaltime10 = (time1.tv_sec*1000000.0 + time1.tv_usec) - (time0.tv_sec*1000000.0 + time0.tv_usec);
fprintf(stderr, "GPU time: %lf msecs ",  (totaltime10)/1000.0F);
gettimeofday(&time0,NULL);
kernel_cpu(A0,B0,977711);
gettimeofday(&time1,NULL);
totaltime10 = (time1.tv_sec*1000000.0 + time1.tv_usec) - (time0.tv_sec*1000000.0 + time0.tv_usec);
fprintf(stderr, "CPU time: %lf msecs ",  (totaltime10)/1000.0F);
int *testA0;
testA0 = (int *)malloc(intBytes);
cudaMemcpy(testA0,d_A0,977711*sizeof(int),cudaMemcpyDeviceToHost);
float *testB0;
testB0 = (float *)malloc(floatBytes);
cudaMemcpy(testB0,d_B0,977711*sizeof(int),cudaMemcpyDeviceToHost);
for(int i=0;i<977711;i++){
if (A0[i] != testA0[i]) {
printf("Invalid kernel ");
break;}
}
free(A0);
free(testA0);
cudaFree(d_A0);
free(B0);
free(testB0);
cudaFree(d_B0);
printf("\n");return 0; }